//+------------------------------------------------------------------+
//|                                            sp market profile.mq4 |
//|                                      Copyright  2008, sptrading | 
//+------------------------------------------------------------------+
#property copyright "sptrading"

#include <mplib.mqh>
#include <stdlib.mqh>

extern bool AsiaSession = true;
extern bool EUSession = true;
extern bool USASession = true;

/**
 Purpose: log pocs to <Symbol>.poc
 Note: read datetimes of market profiles from <Symbol>.mp
*/

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
//----
   string name = mpNameFromPeriod();
   string datetimeFilename = name+".mp";
   string pocFilename = name+ ".poc";
   
   // Sessions  
  int sessions = 0;
  if (AsiaSession)
     sessions |= mpeAsiaSession;
  if (EUSession)
     sessions |= mpeEUSession;
  if (USASession)
     sessions |= mpeUSASession;
   
   bool success = mpMarketProfileLog(datetimeFilename, pocFilename, sessions);
   if (success)
      Alert("Log ", datetimeFilename, " to ", pocFilename, " success");
   else
      Alert("Log ", datetimeFilename, " to ", pocFilename, " failed: ", ErrorDescription(GetLastError()));
   return(0);
}
//+------------------------------------------------------------------+
int start1()
{
//----
  double onetick = 1/(MathPow(10,Digits));  
  string filename = Symbol() + ".mp";
  datetime dt[];
   // Sessions  
  int sessions = 0;
  if (AsiaSession)
     sessions |= mpeAsiaSession;
  if (EUSession)
     sessions |= mpeEUSession;
  if (USASession)
     sessions |= mpeUSASession;

  bool success = mpReadDatetime(dt, filename);
  if (success)
  {   
      // Erase old file
      filename = Symbol() + ".poc";
      int handle=FileOpen(filename, FILE_CSV|FILE_WRITE, 9);
      if (handle > 0)
         FileClose(handle);
         
      int shifts[];
      mpBarShiftsFromDatetime(shifts, dt);
      
      // Log
      // first profile is the current
      int beginBar = 0;
      int size = ArraySize(shifts);
      for (int i = 0; i < size; i++)
      {
         int bars = shifts[i]-beginBar;
         Alert(i, ", ", beginBar, ", ", bars, ", ", TimeToStr(dt[i]));
      
         // Profile prices between high and low of bars
         double prices[];
         mpPrices(prices, beginBar, bars, onetick, sessions);
         // Profile timestamps between high and low of bars
         string mpDt[];
         mpDatetime(mpDt, prices, beginBar, bars, sessions);
         // Lines
         int pocsIndex[];
         mpPocIndex(pocsIndex, mpDt);
         //Alert(mpePOC, mpeStd1Down, mpeStd1Up, mpeStd2Down, mpeStd2Up);
         double pocsPrices[];
         mpPocPrices(pocsPrices, prices, pocsIndex);
         //Alert(pocsPrices[mpePOC], ", ", pocsPrices[mpeStd1Down], ", ", pocsPrices[mpeStd1Up], ", ", pocsPrices[mpeUnitDown], ", ", pocsPrices[mpeUnitUp]);
         mpLogPocPrices(pocsPrices, filename, beginBar, bars, sessions);

         beginBar = shifts[i]+1;
      }
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+